﻿using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess
{
    [TestClass]
    public class EasyDAItemChangedEventArgsTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestMethod]
        public void BinarySerializationTestLiveStream()
        {
            EasyDAClient client = EasyDAClient.SharedInstance;
            int handle = client.SubscribeItem("", LegacyTestDefs.ProgIds.KitServer,
                LegacyTestDefs.DataAccess.ItemIds.Incrementing_1s, 100,
                (_, eventArgs) =>
                    // ReSharper disable AssignNullToNotNullAttribute
                        Tests.BinarySerializationTest(eventArgs));
            // ReSharper restore AssignNullToNotNullAttribute
            AssertUtilities.WaitingPhase(10 * 1000);
            client.UnsubscribeItem(handle);
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("TimeDomain")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLiveStream()
        {
            EasyDAClient client = EasyDAClient.SharedInstance;
            int handle = client.SubscribeItem("", LegacyTestDefs.ProgIds.KitServer,
                LegacyTestDefs.DataAccess.ItemIds.Incrementing_1s, 100,
                (_, eventArgs) =>
                    // ReSharper disable AssignNullToNotNullAttribute
                        Tests.XmlSerializationTest(eventArgs));
            // ReSharper restore AssignNullToNotNullAttribute
            AssertUtilities.WaitingPhase(10 * 1000);
            client.UnsubscribeItem(handle);
        }
    }
}
