﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class BakerHughes_iFix_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$AR.AR_TEXT1.CV" };

        public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$AR.AR_TEXT1.CV" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$AI.FWT_FWP_COMBINED_FLOW.CV",
            "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$AI.FWT_FWP_DISCHARGE_PRESSURE.CV"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://mysticrain:51400/" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            //nameof(Group001_Session_Test04_ActivateSession_UserIdentityAnonymous),
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group003_AttributeServices_Test03_Read_MaxAge),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "pass";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$TX.FWT_FWP_DPUMP_1A_ADJ_OUTPUT.CV" };

        public override string UserName => "user";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] { "nsu=urn:Proficy:iFix:UAServer;ns=2;s=13$TX.FWT_FWP_DPUMP_1A_ADJ_OUTPUT.CV" };
    }
}
