﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class CertecEdv_Atvise_Test : UAInteroperabilityWorkshopTest
    {
        //public override IEnumerable<UANodeDescriptor> ArrayReadableNodes => new UANodeDescriptor[] { "" };

        //public override IEnumerable<UANodeDescriptor> ArrayWriteableNodes => new UANodeDescriptor[] { "" };

        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_double_0000000.double_0000000",
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_int32_0000000.int32_0000000",
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://ei-wrk-l-301:4841" };

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new []
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override string Password => "iop2018";

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=http://www.atvise.com/atServer/UA/;ns=1;s=AGENT.layout_parameters",
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_int32_0000000.int32_0000000",
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_double_0000000.double_0000000",
        };

        public override string UserName => "iop2018";

        public override IEnumerable<UANodeDescriptor> WriteableNodes => new UANodeDescriptor[] 
        {
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_int32_0000000.int32_0000000",
            "ns=1;s=AGENT.OBJECTS.DG1.Folder_double_0000000.double_0000000",
        };
    }
}
