﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class SchneiderElectric_IndusoftWebStudioOpcUAServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Studio ;ns=2;s=Studio.Tags.Application.RO_Dynamic_Integer01",
            "nsu=urn:Studio ;ns=2;s=Studio.Tags.Application.RO_Dynamic_Real01"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[]
        {
            "opc.tcp://192.168.1.29:48010/"
        };

        public override string Password => "admin";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),    // no cert presented
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[]
        {
            "nsu=urn:Studio ;ns=2;s=Studio.Tags.Application.RO_Static_Integer01",
            "nsu=urn:Studio ;ns=2;s=Studio.Tags.Application.RO_Static_Real02"
        };

        public override string UserName => "admin";
    }
}
